> For the complete documentation index, see [llms.txt](https://docs.impler.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.impler.io/validations/bases.md).

# Base Validations

## List of available validators:

1. **String Validator**: This validator ensures that the column value is a string. String and Number are both valid values.
2. **Number Validator**: The Number validator verifies that the column value is a valid numeric entry. It only permits numerical values like `12` but will not allow `12.33` and `john`.
3. **Double Validator**: The Double validator verifies that the column value is either a Number or a Number with decimals. Valid values are `12` and `12.5` but `john` is not valid.
4. **Email Validator**: With the Email validator, you can ensure that the column value conforms to a valid email format. Valid values look like `john@gmail.com` while values like `john` and `john.com` are not valid.
5. **Regex Validator**: The Regex validator enables you to define a custom regular expression pattern that the column value must match.
6. **Select Validator**: Use the Select validator to restrict column values to a predefined set of options. For instance, you can use it to ensure that a "Gender" column contains only values like "Male" or "Female."
7. **Any Validator**: Any validator offers maximum flexibility by allowing any value in the column.

### Validator Enhancements

* **isRequired**: Ensures that a value must exist in each cell for the column.
* **isUnique**: Ensures that the value is unique throughout the column.
* **allowMultiSelect**: Accepts multiple values separated by `,` for the cell.

It's possible to extend validation functionality to adjust according to your needs. Read more in [Custom Validation](/features/custom-validation.md).

***

If you have any questions, suggestions, or comments. Feel free to reach out to us over [**Discord**](https://discord.impler.io). We’re constantly improving to deliver the best Data Importer for your product, and we value your input.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.impler.io/validations/bases.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
